#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/dispatch.h>

/*      .  . */
typedef struct _pulse msg_header_t;

/*          */
typedef struct _MsgBuf {
    msg_header_t	hdr;
    char	*		Buffer;
} MsgBuf_t;

int main() {
MsgBuf_t MsgBuf;
int fd;
char BufReply[100];

if ((fd = name_open("MyService", NAME_FLAG_ATTACH_GLOBAL)) == -1) {
  printf("     \n");  fflush(stdout);
  return EXIT_FAILURE;
}

MsgBuf.hdr.type = 0x5001;           //     
MsgBuf.hdr.subtype = 0x00;

strcpy(MsgBuf.Buffer, ",  !");
if (MsgSend(fd, &MsgBuf, sizeof MsgBuf, BufReply, sizeof BufReply) == -1) {
  printf("      \n");  fflush(stdout);
  name_close(fd);
  return EXIT_FAILURE;
}
printf("     : \"%s\"\n", BufReply);

name_close(fd);
return EXIT_SUCCESS;
}

