#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/dispatch.h>

/*  ࢥ  室  .  . */
typedef struct _pulse msg_header_t;

/*  ᮮ饭 ⮨       */
typedef struct _MsgBuf {
    msg_header_t	hdr;
    char		*	Buffer;
} MsgBuf_t;

int main() {
name_attach_t  * NameServer;
MsgBuf_t MsgBuf;
int rcvid;
char BufReply[100];

/*   쭮  /dev/name/global/MyService  */
if (!(NameServer = name_attach(NULL, "MyService", NAME_FLAG_ATTACH_GLOBAL)))
return EXIT_FAILURE;

/*  ⠭   祭 ᮮ饭  */
while (1) {
  if ((rcvid = MsgReceive(NameServer->chid, &MsgBuf, sizeof MsgBuf, NULL)) == -1 )  {
    printf("訡  祭 ࢥ஬ MyService ᮮ饭  \n");
    fflush(stdout);
    break;
  }

  if (!rcvid)   {					//  祭 
    switch (MsgBuf.hdr.code) {
      case _PULSE_CODE_DISCONNECT:
        /*  ᪮   ⠭ 䫠 _NTO_CHF_DISCONNECT,   */
        /*  ⮬᪨  ᢮ ⠭ ࠭ ⮬ 裡.        */
        /*  ࢥ  믮   ᢮ ஭ ᠬ, 㤠        */
        /*    ᥡ ⭮   "ᮧ⥫쭮".                                                       */
        ConnectDetach(MsgBuf.hdr.scoid);
      break;

      case _PULSE_CODE_UNBLOCK:
        /*   ⠥ ࠧ஢,   ⢥  Reply.       */
        /*   믮 - ⢨, ⮡ ४⭮ ( ᥡ)               */
        /*  ࠡ  ,  -⠪  ⮣  -                */
        /*    !  ⮬   MsgBuf.hdr.value 室 rcvid     */
        MsgReply(MsgBuf.hdr.value.sival_int, EAGAIN, NULL, 0);
      break;
  
      default:  break;
    }
    continue;                                                      //   室   ਥ ᮮ饭
  }

  /*  祭 ᮮ饭 室   ⥬    */
  /*   ᮮ饭 /뢮.  ࠡ뢠.                           */
  if (MsgBuf.hdr.type >= _IO_BASE  &&  MsgBuf.hdr.type <= _IO_MAX) {
    MsgError(rcvid, ENOSYS);
    continue;
  }

  /*     - ᮮ饭  ࢥ. ࠡ뢠.    */
  if (MsgBuf.hdr.type <=0x50001  ||  MsgBuf.hdr.type>=0x500ff)  {
    printf("ࢥ 稫 ᮮ饭 ⭮    ⪮ %#x\n", MsgBuf.hdr.type);
    strcpy(BufReply, "?  ???");
  }
  else {
    printf("ࢥ 稫 ᮮ饭: \"%s\"\n", MsgBuf.Buffer);
    strcpy(BufReply, ",  , ");
  }
  MsgReply(rcvid, EOK, BufReply, strlen(BufReply)+1);

}                                                                            //   ⫨ 祭 ᮮ饭

/*  ᮥ塞  㦡      */
name_detach(NameServer, 0);

return EXIT_SUCCESS;
}


