#include <errno.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/iofunc.h>
#include <sys/dispatch.h>
#include <devctl.h>
#include <locale.h>

#include "/home/ZZZ/TESTS/MessagePassing/MessTest.h"

int PrivatHandler(message_context_t * ctp, int code, unsigned flags, void * handle);
char * IdLabelParse(int id);

static resmgr_connect_funcs_t	connect_funcs;				//   㭪権 裡
static resmgr_io_funcs_t			io_funcs;						//   㭪権 /뢮
static iofunc_attr_t						attr;								//   ਡ⮢ ன⢠

main (int args, char **argv)  {
resmgr_attr_t				resmgr_attr;		//   ਡ⮢  ᮢ
dispatch_t					*dpp;				// ⥫   ᯥਧ樨,
															// ᮤন 䨪 .
dispatch_context_t	*ctp;					//  ⥪⭠ , ᮤন  ᮮ饭,
														//   ஢ /뢮
int								id;
int								result;
char BufferRec[100];
int rcvid;

setlocale(LC_CTYPE, "C-TRADITIONAL");

/*   믮 室 ⢨  樠樨 ⭮ ࢥ */

/* ⠥,   室 ⥯ 믮... */

/* 樠 䥩 ᯥਧ樨 */
if((dpp = dispatch_create()) == NULL) {
  printf("%s:  ࠧ ࠡ稪 ᯥਧ樨.\n", argv[0]);
  return EXIT_FAILURE;
}
/*  १   dpp ᮧ  ᯥਧ樨  */

/* 樠 ਡ⮢  ᮢ */
memset(&resmgr_attr, 0, sizeof resmgr_attr);
resmgr_attr.nparts_max = 1;
resmgr_attr.msg_max_size = MESSIZE_MAX;
/*	 ᫮ 㯭  ஢ /뢮 (IOV) ࠢ 1.	*/
/*  ᨬ ࠧ  祭 ࠢ MESSIZE_MAX.		*/
/*   १ 樠 ਡ  ᮢ		*/

/* 樠 㭪権 ࠡ⪨ ᮮ饭 */
iofunc_func_init(_RESMGR_CONNECT_NFUNCS, &connect_funcs,
		                  _RESMGR_IO_NFUNCS,				 &io_funcs);
/*  १   ⠡ (), 騥 㭪樨 ࠡ⪨	*/
/*   ᯥ樠 ⨯ ᮮ饭:	⠡ 㭪権 裡								*/
/*																		⠡ 㭪権 /뢮.					*/
/*  ᮮ⢥  ࠧ ਭ  㬮砭 㭪樨		*/
/* iofunc_*_default().																											*/
/*   塞 -  㦤																					*/

/* 樠 ᯮ㥬 ன⢮  ਡ⮢ */
iofunc_attr_init(&attr, S_IFNAM | 0666, 0, 0);
attr.nbytes = MESSIZE_MAX+1;
/*  १ 樠   ਡ⮢, ᯮ㥬 ன⢮.	*/
/* S_IFNAM 㪠뢥,  ⨯ ன⢠ - Special named file;											*/
/* ⮢ 䫠 666 । ࠢ 㯠;															*/
/* ᫮ ⮢    ࠢ ࠧ     										*/

/* ਪ९  ன⢠ */
if((id = resmgr_attach(dpp, &resmgr_attr, "/dev/MESSTEST/RM", _FTYPE_ANY, 0,
								 &connect_funcs, &io_funcs, &attr)) == -1) {
  printf("%s:  ਪ९   ᮢ.\n", argv[0]);
  return EXIT_FAILURE;
}

/* 祢 ⢨:  ॣ㥬  襬 㧫  /dev/MESSTEST/RM		*/
/* *dpp  resmgr_attr - 樠஢  ;					*/
/* /dev/MESSTEST/RM - 樨஢  ன⢮ ;				*/
/* _FTYPE_ANY - । ⨯  ன⢠ (  砥			*/
/* ᪠  ⨯  );							*/
/* ࠢ  䫠 ࠧન   䠩 ।,   -			*/
/* ⮫쪮   /dev/MESSTEST/RM;								*/
/* &connect_funcs	-   ணࠬ 裡;					*/
/* &io_funcs		-   ணࠬ /뢮;				*/
/*  attr - 樠஢   ਡ⮢ ⮩⢠				*/

/* 砥  ᮮ饭,   ᬠਢ,  ਢ	*/
/* -  ।祩  㪠뢠 ࠡ稪  ⠪ ᮮ饭 PrivatHandler()	*/
if (message_attach (dpp, NULL, 0x5000, 0x5fff, &PrivatHandler, NULL) == -1 ) {
  printf("H    ਢ ᮮ饭\n");
  return (EXIT_FAILURE);
}

//* 饭 ⥪⭮  */
ctp = dispatch_context_alloc(dpp);
/*   ᮮ饭, ᮤঠ饣  ⮩ , ࠢ  		*/
/* ᫮ ஢ /뢮, ⠪ ᮤঠ  ⮩ , 			*/
/* ⠭  樠樨  ਡ⮢  ᮢ		*/

/*  ⫨ ᮮ饭  ᮢ							*/
while(1) {
  if((ctp = dispatch_block(ctp)) == NULL) {		//   室 ᮮ饭
    printf("訡 \n");
    return EXIT_FAILURE;
  }
/*
printf(" ᮢ 稫 ᮮ饭  %i \n",
ctp->resmgr_context.info.msglen);
*/
  result = dispatch_handler(ctp);				//  ᮮ饭 ᪮,  ᭮ 
															//  ⠡ 㭪権 裡  /뢮 뢠
															// ᮮ⢥ 㭪 ࠡ⪨ ᮮ饭
  if (result)
  printf("M ᮢ  ᬮ ࠡ ᮮ饭 result=%i\n", result);
  fflush(stdout);

}
}

/****************************************************************************/
/*  ࠡ稪 ਢ ᮮ饭, .. ᮮ饭,  			*/
/*  㪫뢠  , 㪠  맮 㭪樨 message_attach()		*/
/*****************************************************************************/
int PrivatHandler(message_context_t * ctp, int code, unsigned flags, void * handle) {
char Buffer [MESSIZE_MAX];

printf("祭 ਢ⭮ ᮮ饭 ⨯ %x  \"%s\"\n", code, IdLabelParse(code));
printf("B  ᮮ饭: <<%s>>\n", (char *)(ctp->msg)+4);
fflush(stdout);

strcpy(Buffer, "K: ,  ⠪");
MsgReply(ctp->rcvid, EOK, Buffer, sizeof(Buffer));

return (0);
}

/*****************************************************************/
/*          㭪 짮⥫᪮ ⥪, ।                      */
/*    ਧ樮     ਧ樮 ⪥   */
/*****************************************************************/
char * IdLabelParse(int id) {
struct IdLabel_t Inventory;
int  i = 0;

while (IdLabel[i].id != id && i<ALLNUM_MYPROC) i++;
if (i==ALLNUM_MYPROC) return Anonimus; else return (IdLabel[i].name);
}

