#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <sys/neutrino.h>
#include <sys/netmgr.h>
#include <spawn.h>
#include <errno.h>
#include <unistd.h>
#include <sys/wait.h>
#include <locale.h>

int main(int argc, char ** argv)  {
int nid;							//    
int PChanid; 				//    
int CChanid; 				//   , 
									//      
int coid;		 				//         
int rcvid;		 				//     
int ErrCode;					//   
char * args[] = {
  "/net/904-3/home/ZZZ/BIN/TestChild",
  "pid  ",
  " ",
  NULL
};
char BufName[100], Bufpid[12], Bufchanid[12], RecBuffer[100];
char SendBuf[100] = ", !";
pid_t procid, childid;
struct inheritance InhProc;

setlocale(LC_CTYPE, "C-TRADITIONAL");

if ((PChanid = ChannelCreate(0)) == -1)
printf ("P: ,     \n");
else printf ("P:  PChanid = %i \n", PChanid);

//strcpy (BufName, "Bed-Test");
strcpy (BufName, "KKK");
args [1] = itoa (procid=getpid(), Bufpid, 10);	//       pid...
args [2] = itoa (PChanid, Bufchanid, 10);		//...   

InhProc.flags = SPAWN_SETND | SPAWN_NOZOMBIE;

if ((nid = netmgr_strtond(BufName, NULL)) == -1)  {
  printf ("P:  %s\n", BufName);
  return (-1);
}
else printf ("P:   %s,  nid = %i\n", BufName, nid);

InhProc.nd = nid;

//sprintf(BufName, "/net/Bed-Test/");
sprintf(BufName, "/net/KKK/");
chroot(BufName); 

errno = 0;
childid = spawn(args[0], 0, NULL, &InhProc, args, NULL);
ErrCode = errno;

sprintf(BufName, "/net/904-3/");
chroot(BufName);

if (childid == -1) printf ("P:    , errno = %i\n", ErrCode);
else printf ("P:  id = %i,    id = %i\n",
procid, childid);

if ((rcvid = MsgReceive(PChanid, RecBuffer, 100, NULL)) == -1)
printf ("P:      \n");
else {
  printf ("P:      id :\"%s\"\n", RecBuffer);
  CChanid = atoi (RecBuffer);
  strcpy (RecBuffer, ", !");
  if (MsgReply(rcvid, EOK, RecBuffer, 100) == -1)
  printf ("P: -    . ,  ?\n");
}

if ((coid = ConnectAttach(nid, childid, CChanid, _NTO_SIDE_CHANNEL, 0)) == -1)  {
  printf ("P: ,        :"
			 "nid = %i childid = %i CChanid = %i\n", nid, childid, CChanid);
  return (-1);
}

printf ("P:   coid = %i  \n", coid);

errno = 0;
if (MsgSend(coid, SendBuf, 100, SendBuf, 100) == -1)
printf ("P:  MsgSend  errno = %i\n", errno);
else printf ("P:    MsgSend(): \"%s\"\n", SendBuf);

printf ("P:  \n");

ChannelDestroy (PChanid);
ConnectDetach (CChanid);
return(0);
}

