#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <limits.h>
#include <fcntl.h>

void main( int argc, char *argv[] ) {
   char sResName[ _POSIX_PATH_MAX + 1 ] = "/dev/wmng";
   if( argc > 1 ) strcpy( sResName, argv[ 1 ] );
   int df = open( sResName,  O_RDWR | O_NONBLOCK );
   if( df < 0 ) perror( "device open" ), exit( EXIT_FAILURE );
   cout << "open " << sResName << " , desc. =  " << df << endl;
   char ibuf[ 2048 ], obuf[ 2048 ];
   int r, w;
   while( true ) {
      if( ( r = read( df, obuf, sizeof( obuf ) ) ) < 0 ) break;
      cout << '#' << obuf << endl;
      cout << '>' << flush;
      cin >> ibuf;
      if( ( w = write( df, ibuf, strlen( ibuf ) + 1 ) ) <= 0 ) break;
   };
   if( r < 0 ) perror( "read error" );
   if( w < 0 ) perror( "write error" );
   exit( EXIT_FAILURE );
};

