#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <sys/neutrino.h>
#include <pthread.h>
#include <sys/syspage.h>

static double cycle2milisec ( uint64_t ccl ) {
   const static double s2m = 1.E+3;
   const static uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:
   return (double)ccl * s2m / (double)cps; 
};

void* threadfunc ( void* data ) {
   pthread_exit( NULL );
};

int main( int argc, char *argv[] ) {
   uint64_t t = ClockCycles();
   pthread_t tid;
   pthread_create( &tid, NULL, threadfunc, NULL );
   pthread_join( tid, NULL );
   t = ClockCycles() - t;
   cout << "Thread time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;    
   exit( EXIT_SUCCESS );
};


