#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include <sys/neutrino.h>

int main( int argc, char *argv[] ) {
   int opt, val; 
   unsigned long N = 1000;
   while ( ( opt = getopt( argc, argv, "n:" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) N = val;
            break;
         default :
            cout << "parse command line failed" << endl, exit( EXIT_FAILURE );
            break;
       }
   };
   uint64_t s = 0;
   for( int i = 0; i < N; i++ ) {
      uint64_t t = ClockCycles();
      t = ClockCycles() - t;
      s += t;
   };
   cout << "cycles - " << N << "; one time mark - " << s / N << endl;
   exit( EXIT_SUCCESS );
};

