#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include "p4common.h"

int main( int argc, char *argv[] ) {
   int numpar = 1;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) numpar = atoi( argv[ 1 ] );
   _clockperiod clcold = setclock( argc > 2 ? atoi( argv[ 2 ] ) : 0 );      
   cout << "Rescheduling interval = " << sched_interval() << " msec." << endl;      
   uint64_t t = ClockCycles();
   workproc( 1000 * numpar );
   t = ClockCycles() - t;
   cout << "Single scheduling time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;
   ClockPeriod( CLOCK_REALTIME, &clcold, NULL, 0 );
   exit( EXIT_SUCCESS );
};

