#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <signal.h>
#include <unistd.h>


int main( int argc, char *argv[] ) {
   int opt, val, sig = SIGRTMIN, num = 10;
   pid_t pid = 0;
   while ( ( opt = getopt( argc, argv, "s:n:p:") ) != -1 ) {
      switch( opt ) {
         case 's' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            sig = val;
            break;
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            num = val;
            break;
         case 'p' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            pid = val;
            break;
         default :
            perror( "parse command line failed" ), exit( EXIT_FAILURE );
            break;
      }
   };
   if( pid == 0 ) perror( "illegal PID" ), exit( EXIT_FAILURE );
   while( num-- > 0 ) kill( pid, sig );   
   exit( EXIT_SUCCESS );      
};




        

